export declare const clientTemplate = "\nimport (\n\t\"context\"\n\t\"net/http\"\n\n\t\"github.com/wundergraph/client-go/pkg/execute\"\n)\n\ntype options struct {\n\thttpClient *http.Client\n\tbaseURL string\n}\n\ntype Option func(o *options)\n\nfunc WithHttpClient(httpClient *http.Client) Option {\n\treturn func(o *options) {\n\t\to.httpClient = httpClient\n\t}\n}\n\nfunc WithBaseURL(baseURL string) Option {\n\treturn func(o *options) {\n\t\to.baseURL = baseURL\n\t}\n}\n\ntype Client struct {\n\thttpClient  *http.Client\n\tbaseURL string\n}\n\nfunc New(opts ...Option) *Client {\n\tvar o options\n\tfor _, opt := range opts {\n\t\topt(&o)\n\t}\n\thttpClient := o.httpClient\n\tif httpClient == nil {\n\t\thttpClient = http.DefaultClient\n\t}\n\tbaseURL := o.baseURL\n\tif baseURL == \"\" {\n\t\tbaseURL = \"{{baseURL}}\"\n\t}\n\treturn &Client{httpClient, baseURL}\n}\n\nfunc (c *Client) Queries() *Queries {\n\treturn &Queries{c}\n}\n\nfunc (c *Client) Mutations() *Mutations {\n\treturn &Mutations{c}\n}\n\nfunc (c *Client) Subscriptions() *Subscriptions {\n\treturn &Subscriptions{c}\n}\n\nfunc (c *Client) LiveQueries() *LiveQueries {\n\treturn &LiveQueries{c}\n}\n\ntype Queries struct {\n\tclient *Client\n}\n\n{{#each queries }}\nfunc (q *Queries) {{name}}(ctx context.Context{{#if hasInput}}, input {{name}}Input{{/if}}) (*{{name}}Response, error) {\n\treturn execute.Query[{{#if hasInput}}{{name}}Input{{else}}any{{/if}}, {{name}}Response](q.client.httpClient, ctx, q.client.baseURL, \"/{{name}}\", {{#if hasInput}}&input{{else}}nil{{/if}})\n}\n{{/each}}\n\ntype LiveQueries struct {\n\tclient *Client\n}\n\n{{#each queries}}\nfunc (l *LiveQueries) {{name}}(ctx context.Context{{#if hasInput}}, input {{name}}Input{{/if}}) (*execute.Stream[{{name}}Response], error) {\n\treturn execute.LiveQuery[{{#if hasInput}}{{name}}Input{{else}}any{{/if}}, {{name}}Response](l.client.httpClient, ctx, l.client.baseURL, \"/{{name}}\", {{#if hasInput}}&input{{else}}nil{{/if}})\n}\n{{/each}}\n\ntype Mutations struct {\n\tclient *Client\n}\n\n{{#each mutations}}\nfunc (m *Mutations) {{name}}(ctx context.Context{{#if hasInput}}, input {{name}}Input{{/if}}) (*{{name}}Response, error) {\n\treturn execute.Mutate[{{#if hasInput}}{{name}}Input{{else}}any{{/if}}, {{name}}Response](m.client.httpClient, ctx, m.client.baseURL, \"/{{name}}\", {{#if hasInput}}&input{{else}}nil{{/if}})\n}\n{{/each}}\n\ntype Subscriptions struct {\n\tclient *Client\n}\n\n{{#each subscriptions}}\nfunc (s *Subscriptions) {{name}}(ctx context.Context{{#if hasInput}}, input {{name}}Input{{/if}}) (*execute.Stream[{{name}}Response], error) {\n\treturn execute.Subscribe[{{#if hasInput}}{{name}}Input{{else}}any{{/if}}, {{name}}Response](s.client.httpClient, ctx, s.client.baseURL, \"/{{name}}\", {{#if hasInput}}&input{{else}}nil{{/if}})\n}\n{{/each}}\n";
